#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "gpu2device4xi5test.py">
#<abstract4xi abstract = "tests gpu4xi"/>
#<verify4xi verification = "11" target = "gpu2device4xi.py"/>
#<contextualize4xi context = "device4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = [ 'main',
            'print_trace4xi',
            'gpu2device4xi5test',
            'set_trace4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>



# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from gpu2device4xi import GPU4Xi                                                                                  # class to be tested 
from gpu2device4xi import init2gpu4xi                                                                             # function to be tested 
from gpu2device4xi import set2gpu4xi                                                                              # function to be tested 
from gpu2device4xi import get2gpu4xi                                                                              # function to be tested 

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
                                                                                                                  # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
     
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set_trace4xi" usage = "
#   setting trace using pickle4xi sub functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def set_trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    t2xi = Print4Xi()

    
    print('=' *33)
    print("(Step 1A/33) of SET_TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)")
    print('=' *33)
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
        
    keys2pickledb = sorted(PickleKB4Xi.keys())
    
    for key2pickledb in keys2pickledb:
     
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
        # STARTING LETTER :  _    

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        
        # print('~' *33)        
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # STARTING DICTIONARY:  {'xml_trace_sense4xi': 'NACK4XI', '_reduce_partial4xi': 'NACK4XI', 'set_listener4xi': 'NACK4XI', 'sense_lock4xi': 'NACK4XI', '_run_after_forkers4xi ': 'NACK4XI', 'ace_cache4xi': 'NACK4XI', 'xml_trace_reason4xi': 'NACK4XI', 'reason_cache4xi': 'NACK4XI', '_rebuild_partial4xi': 'NACK4XI', 'init_listener4xi': 'NACK4XI', '_MainProcess4Xi': 'NACK4XI', 'close_cache4xi': 'NACK4XI', '_xml_loads4xi': 'NACK4XI', 'ace_listener4xi': 'NACK4XI', '_xml_dumps4xi': 'NACK4XI', '_cleanup4xi': 'NACK4XI', '_serve4xi': 'NACK4XI', 'reason_listener4xi': 'NACK4XI', '_run_after_forkers4xi': 'NACK4XI', '_exit_function4xi': 'NACK4XI', 'clear_cache4xi': 'NACK4XI', '_finalizer4xi': 'NACK4XI', 'ace_lock4xi': 'NACK4XI', 'acquire_lock4xi': 'NACK4XI', '_get_listener4xi': 'NACK4XI', 'sense_listener4xi': 'NACK4XI', 'release_lock4xi': 'NACK4XI', 'get_cache4xi': 'NACK4XI', 'init_cache4xi': 'NACK4XI', 'reason_lock4xi': 'NACK4XI', '_reduce_method_descriptor4xi': 'NACK4XI', 'reset_cache4xi': 'NACK4XI', '_reset4xi': 'NACK4XI', 'add_cache4xi': 'NACK4XI', 'reset_listener4xi': 'NACK4XI', '_run_finalizers4xi': 'NACK4XI', 'remove_cache4xi': 'NACK4XI', '_new_value4xi': 'NACK4XI', 'sense_cache4xi': 'NACK4XI', 'get_listener4xi': 'NACK4XI', '_bootstrap4xi': 'NACK4XI', 'xml_trace_ace4xi': 'NACK4XI', 'get_lock4xi': 'NACK4XI', '_C4Xi': 'NACK4XI', '_check_logger_class4xi': 'NACK4XI', 'init_lock4xi': 'NACK4XI', '_reduce_method4xi': 'NACK4XI', 'reset_lock4xi': 'NACK4XI'}

                    
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # _C4Xi, _MainProcess4Xi, _bootstrap4xi ....  
            
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
            
            

            # ---------------------------------------------------------------------------------    
            # skip pickling
            # ---------------------------------------------------------------------------------     
        
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                print("SET_TRACE4XI.PY - MARKED TO BE TRACED OBJECT: ", object2pickle)
                # CPU4Xi
                # Device4Xi
                # get2cpu4xi
                # get2device4xi
                # get2gpu4xi
                # get2platformids4xi
                # get2platforminfo4xi
                # init2cpu4xi
                # init2device4xi
                # init2gpu4xi
                # init2platformids4xi
                # init2platforminfo4xi
                # PlatformID4Xi
                # PlatformInfo4Xi
                # set2cpu4xi
                # set2device4xi
                # set2gpu4xi
                # set2platformids4xi
                # set2platforminfo4xi
                                                                                                                    
            
                dictionary2pickle[key2dictionary] = 'TRACE4XI' 
                # print('~' *33)
            else:
                pass  
                   
                                         
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("*** ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
            

        
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
            
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # COMPLETED  DICTIONARY:
        #  {'xml_trace_sense4xi': 'ACK4XI', '_reduce_partial4xi': 'ACK4XI', 'set_listener4xi': 'ACK4XI', 'sense_lock4xi': 'ACK4XI', '_run_after_forkers4xi ': 'ACK4XI', 'ace_cache4xi': 'ACK4XI', 'xml_trace_reason4xi': 'ACK4XI', 'reason_cache4xi': 'ACK4XI', '_rebuild_partial4xi': 'ACK4XI', 'init_listener4xi': 'ACK4XI', '_MainProcess4Xi': 'ACK4XI', 'close_cache4xi': 'ACK4XI', '_xml_loads4xi': 'ACK4XI', 'ace_listener4xi': 'ACK4XI', '_xml_dumps4xi': 'ACK4XI', '_cleanup4xi': 'ACK4XI', '_serve4xi': 'ACK4XI', 'reason_listener4xi': 'ACK4XI', '_run_after_forkers4xi': 'ACK4XI', '_exit_function4xi': 'ACK4XI', 'clear_cache4xi': 'ACK4XI', '_finalizer4xi': 'ACK4XI', 'ace_lock4xi': 'ACK4XI', 'acquire_lock4xi': 'ACK4XI', '_get_listener4xi': 'ACK4XI', 'sense_listener4xi': 'ACK4XI', 'release_lock4xi': 'ACK4XI', 'get_cache4xi': 'ACK4XI', 'init_cache4xi': 'ACK4XI', 'reason_lock4xi': 'ACK4XI', '_reduce_method_descriptor4xi': 'ACK4XI', 'reset_cache4xi': 'ACK4XI', '_reset4xi': 'ACK4XI', 'add_cache4xi': 'ACK4XI', 'reset_listener4xi': 'ACK4XI', '_run_finalizers4xi': 'ACK4XI', 'remove_cache4xi': 'ACK4XI', '_new_value4xi': 'ACK4XI', 'sense_cache4xi': 'ACK4XI', 'get_listener4xi': 'ACK4XI', '_bootstrap4xi': 'ACK4XI', 'xml_trace_ace4xi': 'ACK4XI', 'get_lock4xi': 'ACK4XI', '_C4Xi': 'ACK4XI', '_check_logger_class4xi': 'ACK4XI', 'init_lock4xi': 'ACK4XI', '_reduce_method4xi': 'ACK4XI', 'reset_lock4xi': 'ACK4XI'}

        
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
                    
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # COMPLETED LETTER :  _, a ... z            
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------  
           
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
 
    print('=' *33)
    print("(Step 33/33) of SET_TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)")
    print('=' *33)
            
#</function4xi> 
       

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace for gpu4xi test
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-gpu2device4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python33/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing GPU in system.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">GPU sensed in system.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-gpu2device4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python33/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python33/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for GPU in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-gpu2device4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python33/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python33/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for GPU in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of GPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "gpu2device4xi5test" usage = "
# tests gpu4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def gpu2device4xi5test():
    global t2xi 
    global trace_object_count
    
    # ---------------------------------------------------------------------------------------------    
    # Set Trace
    # ---------------------------------------------------------------------------------------------     
    set_trace4xi()

    # ---------------------------------------------------------------------------------------------
    # START                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 1A/33) OF GPU4XI5TEST - STARTED ', time4xi())
    print('=' *33)   
    
    # ---------------------------------------------------------------------------------------------
    # PHASE I: FUNCTION TESTS                          
    # ---------------------------------------------------------------------------------------------
    
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 2A/33) OF GPU4XI5TEST - TRYING TO INITIALIZE GPU4XI', time4xi())
    print('=' *33)       
    try:
        gpu2xi = init2gpu4xi()                                                                                      # no parameters - the system should initialize all   
        print('(Step 2B/33) OF GPU4XI5TEST - INITIALIZED GPU4XI TO: ', gpu2xi)
        #  {'RESOLUTION2TIMER4PROFILING': 1,
        #  'ID2PLATFORM': '0000000001509568',
        #  'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK',
        #  'NATIVE2WIDTHLONG4VECTOR': 0,
        #  'MAX2UNITS4COMPUTE': 10,
        #  'SIZE2MEMORY4GLOBAL': 536870912,
        #  'NATIVE2WIDTHFLOAT4VECTOR': 0,
        #  'MAX2SIZE4WORKGROUP': 256,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 16,
        #  'SIZE2CACHE': 0,
        #  'IEEE754-2008FUSED2MULTIPLY-ADD': 'ACK',
        #  'TYPE4CACHE': None,
        #  'PREFERRED2WIDTHINT4VECTOR': 4,
        #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 64,
        #  'NATIVE2WIDTHINT4VECTOR': 0,
        #  'SIZE2BUFFER4CONSTANT': 65536,
        #  'EXECUTE2FUNCTION4NATIVE': 'NACK',
        #  'PREFERRED2WIDTHDOUBLE4VECTOR': 0,
        #  'MAX2NUMBER4CONSTANTARGS': 8,
        #  'VERSION2DRIVER': 'CAL 1.4.900',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_gl_sharing cl_amd_device_attribute_query cl_khr_d3d10_sharing ',
        #  'AVAILABLE2COMPILER': 'ACK',
        #  'MAX2DIMENSIONS4WORKITEMS': 3,
        #  'SUPPORT2CORRECTION4ERROR': 0,
        #  'BITS2ADDRESS': 32,
        #  'AVAILABLE': 'ACK',
        #  'SIZE2MEMORY4LOCAL': 16384,
        #  'VENDOR': 'Advanced Micro Devices, Inc.',
        #  'SUPPORT2IMAGE': 'NACK',
        #  'MAX2SIZE4KERNELARGUMENT': 1024,
        #  'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A',
        #  'OUT-OF-ORDER2QUEUE': 'NACK',
        #  'ALIGNMENT2ADDRESS4BASE': 32768,
        #  'PROFILE': 'FULL_PROFILE',
        #  'TYPE2MEMORY4LOCAL': 'Global',
        #  'PREFERRED2WIDTHFLOAT4VECTOR': 4,
        #  'PREFERRED2WIDTHLONG4VECTOR': 2,
        #  'MAX2FREQUENCY4CLOCK': 750,
        #  'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4021,
        #  'MAX2WORKITEM2': 256,
        #  'NATIVE2WIDTHDOUBLE4VECTOR': 0,
        #  'ROUND2ZERO': 'ACK',
        #  'NAME': 'ATI RV770',
        #  'MAX2WORKITEM1': 256,
        #  'MAX2WORKITEM0': 256,
        #  'SIZE2LINE4CACHE': 0,
        #  'MAX2ALLOCATION4MEMORY': 134217728,
        #  'NATIVE2WIDTHCHAR4VECTOR': 0,
        #  'QUIET2NANS': 'ACK',
        #  'NATIVE2WIDTHSHORT4VECTOR': 0,
        #  'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.0 ATI-Stream-v2.3 (451)',
        #  'NACK2RETURN': ' ',
        #  'MEMORY2UNIFIED4HOSTANDDEVICE': 0,
        #  'ENDIANESS2DEVICE': 'Little',
        #  'MINIMUM2ALIGNMENT4DATATYPE': 128,
        #  'ROUND2+VE3INFINITY': 'ACK',
        #  'TYPE': 'CL_DEVICE_TYPE_GPU',
        #  'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'NACK'
        # }
 
                                      
    except:
        print('(Step 2Z/33) OF GPU4XI5TEST *** FAILED TO INITIALIZE GPU4XI', time4xi()) 
    
    # ---------------------------------------------------------------------------------------------
    # GET WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 3A/33) OF GPU4XI5TEST - TRYING TO GET GPU4XI', time4xi())
    print('=' *33)    
    try:
        
        gpu2xi = get2gpu4xi()
        print('(Step 3B/33) OF GPU4XI5TEST - GOT GPU4XI: ', gpu2xi)
        # {'RESOLUTION2TIMER4PROFILING': 1,
        #  'ID2PLATFORM': '0000000001509568',
        #  'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK',
        #  'NATIVE2WIDTHLONG4VECTOR': 0,
        #  'MAX2UNITS4COMPUTE': 10,
        #  'SIZE2MEMORY4GLOBAL': 536870912,
        #  'NATIVE2WIDTHFLOAT4VECTOR': 0,
        #  'MAX2SIZE4WORKGROUP': 256,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 16,
        #  'SIZE2CACHE': 0,
        #  'IEEE754-2008FUSED2MULTIPLY-ADD': 'ACK',
        #  'TYPE4CACHE': None,
        #  'PREFERRED2WIDTHINT4VECTOR': 4,
        #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 64,
        #  'NATIVE2WIDTHINT4VECTOR': 0,
        #  'SIZE2BUFFER4CONSTANT': 65536,
        #  'EXECUTE2FUNCTION4NATIVE': 'NACK',
        #  'PREFERRED2WIDTHDOUBLE4VECTOR': 0,
        #  'MAX2NUMBER4CONSTANTARGS': 8,
        #  'VERSION2DRIVER': 'CAL 1.4.900',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_gl_sharing cl_amd_device_attribute_query cl_khr_d3d10_sharing ',
        #  'AVAILABLE2COMPILER': 'ACK',
        #  'MAX2DIMENSIONS4WORKITEMS': 3,
        #  'SUPPORT2CORRECTION4ERROR': 0,
        #  'BITS2ADDRESS': 32,
        #  'AVAILABLE': 'ACK',
        #  'SIZE2MEMORY4LOCAL': 16384,
        #  'VENDOR': 'Advanced Micro Devices, Inc.', 
        #  'SUPPORT2IMAGE': 'NACK',
        #  'MAX2SIZE4KERNELARGUMENT': 1024,
        #  'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A',
        #  'OUT-OF-ORDER2QUEUE': 'NACK',
        #  'ALIGNMENT2ADDRESS4BASE': 32768,
        #  'PROFILE': 'FULL_PROFILE',
        #  'TYPE2MEMORY4LOCAL': 'Global',
        #  'PREFERRED2WIDTHFLOAT4VECTOR': 4,
        #  'PREFERRED2WIDTHLONG4VECTOR': 2,
        #  'MAX2FREQUENCY4CLOCK': 750,
        #  'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4021,
        #  'MAX2WORKITEM2': 256,
        #  'NATIVE2WIDTHDOUBLE4VECTOR': 0,
        #  'ROUND2ZERO': 'ACK',
        #  'NAME': 'ATI RV770',
        #  'MAX2WORKITEM1': 256,
        #  'MAX2WORKITEM0': 256,
        #  'SIZE2LINE4CACHE': 0,
        #  'MAX2ALLOCATION4MEMORY': 134217728,
        #  'NATIVE2WIDTHCHAR4VECTOR': 0,
        #  'QUIET2NANS': 'ACK',
        #  'NATIVE2WIDTHSHORT4VECTOR': 0,
        #  'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.0 ATI-Stream-v2.3 (451)',
        #  'NACK2RETURN': ' ',
        #  'MEMORY2UNIFIED4HOSTANDDEVICE': 0,
        #  'ENDIANESS2DEVICE': 'Little',
        #  'MINIMUM2ALIGNMENT4DATATYPE': 128,
        #  'ROUND2+VE3INFINITY': 'ACK',
        #  'TYPE': 'CL_DEVICE_TYPE_GPU',
        #  'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'NACK'}

         
    except:
        print('(Step 3Z/33) OF GPU4XI5TEST *** FAILED TO GET GPU4XI', time4xi())
            
    
    # ---------------------------------------------------------------------------------------------
    # SET GPU's ID, TYPE, MAXIMUM COMPUTE UNITS WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 4A/33) OF GPU4XI5TEST - TRYING TO SET GPU ID, TYPE AND MAXIMUM COMPUTE UNITS ', time4xi())
    print('=' *33)       
    task4set2gpu = {}
    task4set2gpu['ID'] = 4098
    task4set2gpu['TYPE'] = 'CL_DEVICE_TYPE_GPU'
    task4set2gpu['MAX2UNITS4COMPUTE'] = 0                                                                           # ZERO CORES
    
     
    try:                               
        response4set2gpu = set2gpu4xi(task4set2gpu)                                                       
        print('(Step 4B/33) OF GPU4XI5TEST - RESPONSE4SET2GPU : ', response4set2gpu)                                
        # 
        
    except:
        print('(Step 4Z1/33) OF GPU4XI5TEST *** FAILED TO SET GPU ID, TYPE AND MAXIMUM COMPUTE UNITS ', time4xi())  
        
    task4set2gpu['MAX2UNITS4COMPUTE'] = 2                                                                           # LESS THAN POSSIBLE 
    try:                               
        response4set2gpu = set2gpu4xi(task4set2gpu)                                                       
        print('(Step 4C/33) OF GPU4XI5TEST - RESPONSE4SET2GPU : ', response4set2gpu)
        # 
        
    except:
        print('(Step 4Z2/33) OF GPU4XI5TEST *** FAILED TO SET GPU ID, TYPE AND MAXIMUM COMPUTE UNITS ', time4xi()) 
        
    task4set2gpu['MAX2UNITS4COMPUTE'] = 100                                                                         # TOO MANY CORES 
    try:                               
        response4set2gpu = set2gpu4xi(task4set2gpu)                                                       
        print('(Step 4D/33) OF GPU4XI5TEST - RESPONSE4SET2GPU : ', response4set2gpu) 
        # {'RESOLUTION2TIMER4PROFILING': 1,
        #  'ID2PLATFORM': '0000000001509568',
        #  'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK',
        #  'NATIVE2WIDTHLONG4VECTOR': 0,
        #  'MAX2UNITS4COMPUTE': 10, <------------ corrected !
        #  'SIZE2MEMORY4GLOBAL': 536870912
        # ...
        
    except:
        print('(Step 4Z3/33) OF GPU4XI5TEST *** FAILED TO SET GPU ID, TYPE AND MAXIMUM COMPUTE UNITS ', time4xi()) 
           
    # ---------------------------------------------------------------------------------------------
    # PHASE II: class tests                          
    # ---------------------------------------------------------------------------------------------
    print('=' *33)          
    print('(Step 5A/33) OF GPU4XI5TEST - CREATING GPU4XI OBJECT')
    print('=' *33)  
    try:
        # ---------------------------------------------------------------------------------------------
        # CREATE OBJECT                        
        # ---------------------------------------------------------------------------------------------        
        cc2xi = GPU4Xi()
        print('(Step 5B/33) OF GPU4XI5TEST - CREATED GPU4XI OBJECT: ', cc2xi)
        # <gpu2device4xi.GPU4Xi object at 0x000000000321FA58>  
         
    except:
        print('(Step 5Z/33) OF GPU4XI5TEST *** FAILED TO CREATE GPU4XI OBJECT')
    
    # ---------------------------------------------------------------------------------------------
    # GET METHOD                        
    # ---------------------------------------------------------------------------------------------          
    print('(Step 6A/33) OF GPU4XI5TEST - TRYING TO GET GPU')
    try:                               
        gpu6xi = cc2xi.get2gpu()                                  
        print('(Step 6B/33) OF GPU4XI5TEST - GOT GPU: ', gpu6xi)                                                    
        # {'RESOLUTION2TIMER4PROFILING': 1, 'ID2PLATFORM': '0000000001509568', ...
    except:
        print('(Step 6Z/33) OF GPU4XI5TEST *** FAILED TO GET GPU')   
     
    
    
    # ---------------------------------------------------------------------------------------------
    # INIT GPU's ID, TYPE AND MAX COMPUTING UNITS WITH METHOD                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 7A/33) OF GPU4XI5TEST - TRYING TO INIT GPU ID AND TYPE', time4xi())
    print('=' *33)       
    task4set2gpu = {} 
    task4set2gpu['ID'] = 4098
    task4set2gpu['TYPE'] = 'CL_DEVICE_TYPE_GPU'
    task4set2gpu['MAX2UNITS4COMPUTE'] = 2                                                                           # 2 CORES
  
    try:                               
        response4set2gpu = cc2xi.init2gpu(task4set2gpu)                                                        
        print('(Step 7B/33) OF GPU4XI5TEST - RESPONSE4SET2GPU : ', response4set2gpu)                                
        # {'NACK2RETURN': ' 5Z16Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1',
        #  'ACK2RETURN': ' 1C2A3A4A',
        #  'TYPE': 'CL_DEVICE_TYPE_GPU',
        #  'ID': 4098, 
        #  'MAX2UNITS4COMPUTE': 2
        # } <-- ONLY THE GIVE ATTRIBUTES INITIALIZED IF ANY GIVEN (IF NONE GIVEN THEN ALL WILL BE INITIALIZED)   
 
 
    except:
        print('(Step 7Z1/33) OF GPU4XI5TEST *** FAILED TO SET GPU ID AND TYPE ', time4xi())   
        
    
    # ---------------------------------------------------------------------------------------------
    # RESET GPU GIVING ALL ATTRIBUTES - DEPICT WITH 8           
    # ---------------------------------------------------------------------------------------------          
    print('=' *33)          
    print('(Step 8A/33) OF GPU4XI5TEST - TRYING TO SET ALL ATTRIBUTES TO GPU ', time4xi())   
    print('=' *33)       

    task4set2gpu = {}                                                                                      # 
    task4set2gpu['ID'] =                                                       40218                       # DEFAULT ID for GPU 
    task4set2gpu['TYPE'] =                                     'CL_DEVICE_TYPE_GPU8'                       # 
    task4set2gpu['MAX2UNITS4COMPUTE'] =                                          88                        # THE NUMBER OF GPU CORES AVAILABLE                                                                      
    task4set2gpu['NAME'] =                                              'ATI RV7708'                       # 
    task4set2gpu['MAX2DIMENSIONS4WORKITEMS'] = 			                       8
    task4set2gpu['MAX2WORKITEM0'] = 				                             258
    task4set2gpu['MAX2WORKITEM1'] = 				                             258
    task4set2gpu['MAX2WORKITEM2'] = 				                             258
    task4set2gpu['MAX2SIZE4WORKGROUP'] = 				                         258
    task4set2gpu['PREFERRED2WIDTHCHAR4VECTOR'] = 			                      18
    task4set2gpu['PREFERRED2WIDTHSHORT4VECTOR'] = 			                       8
    task4set2gpu['PREFERRED2WIDTHINT4VECTOR'] = 			                       8
    task4set2gpu['PREFERRED2WIDTHLONG4VECTOR'] = 			                       8
    task4set2gpu['PREFERRED2WIDTHFLOAT4VECTOR'] = 			                       8
    task4set2gpu['PREFERRED2WIDTHDOUBLE4VECTOR'] = 		                       8
    task4set2gpu['NATIVE2WIDTHCHAR4VECTOR'] = 			                           8
    task4set2gpu['NATIVE2WIDTHSHORT4VECTOR'] = 			                       8
    task4set2gpu['NATIVE2WIDTHINT4VECTOR'] = 			                           8
    task4set2gpu['NATIVE2WIDTHLONG4VECTOR'] = 			                           8
    task4set2gpu['NATIVE2WIDTHFLOAT4VECTOR'] = 			                       8
    task4set2gpu['NATIVE2WIDTHDOUBLE4VECTOR'] = 			                       8
    task4set2gpu['MAX2FREQUENCY4CLOCK'] = 				                         758                         # MHz
    task4set2gpu['BITS2ADDRESS'] = 					                          38
    task4set2gpu['MAX2ALLOCATION4MEMORY'] = 			                   134217728
    task4set2gpu['SUPPORT2IMAGE'] = 				                         'NACK8'
    task4set2gpu['MAX2SIZE4KERNELARGUMENT'] = 			                        1028
    task4set2gpu['ALIGNMENT2ADDRESS4BASE'] = 		                           32768
    task4set2gpu['MINIMUM2ALIGNMENT4DATATYPE'] = 	                             128 
    task4set2gpu['DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY'] = 		  'NACK8'
    task4set2gpu['QUIET2NANS'] = 					                          'ACK8'
    task4set2gpu['ROUND2NEAREST4EVEN'] = 			                          'ACK8'
    task4set2gpu['ROUND2ZERO'] = 				                              'ACK8'
    task4set2gpu['ROUND2+VE3INFINITY'] = 			                          'ACK8'
    task4set2gpu['IEEE754-2008FUSED2MULTIPLY-ADD'] = 		                  'ACK8'
    task4set2gpu['TYPE4CACHE'] = 					                               8
    task4set2gpu['SIZE2LINE4CACHE'] = 				                               8
            
    task4set2gpu['SIZE2CACHE'] = 					                               8
    task4set2gpu['SIZE2MEMORY4GLOBAL'] = 				                   536870918
    task4set2gpu['SIZE2BUFFER4CONSTANT'] = 				                   65538
    task4set2gpu['MAX2NUMBER4CONSTANTARGS'] = 			                           8
            
    task4set2gpu['TYPE2MEMORY4LOCAL'] = 				                    'Global8'
    task4set2gpu['SIZE2MEMORY4LOCAL'] = 				                       16388
    task4set2gpu['SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL'] = 	                  68
            
            
    task4set2gpu['SUPPORT2CORRECTION4ERROR'] = 			                       8
    task4set2gpu['MEMORY2UNIFIED4HOSTANDDEVICE'] = 		                       8
    task4set2gpu['RESOLUTION2TIMER4PROFILING'] = 			                       8
    task4set2gpu['ENDIANESS2DEVICE'] = 				                   'Little8'
    task4set2gpu['AVAILABLE'] = 					                          'ACK8'
    task4set2gpu['AVAILABLE2COMPILER'] = 				                      'ACK8'
            			 
    task4set2gpu['EXECUTE2KERNELS4OPENCL'] = 			                      'ACK8'
    task4set2gpu['EXECUTE2FUNCTION4NATIVE'] = 			                     'NACK8'
    				 
    task4set2gpu['OUT-OF-ORDER2QUEUE'] = 				                     'NACK8'
    task4set2gpu['PROFILING2QUEUE'] = 					                      'ACK8'
    task4set2gpu['ID2PLATFORM'] = 					              '0000000001509568'
            
    task4set2gpu['VENDOR'] = 					      'Advanced Micro Devices, Inc8'
    task4set2gpu['VERSION2DRIVER'] = 				                   'CAL 1.4.908'
    task4set2gpu['PROFILE'] = 					                     'FULL_PROFILE8'
    task4set2gpu['VERSION'] = 					                      'OpenCL 1.0 ATI-Stream-v2.3 (458)'
    task4set2gpu['EXTENSIONS'] = 				  'cl_amd_fp64 cl_khr_gl_sharing cl_amd_device_attribute_query cl_khr_d3d10_sharing8' 
    
    
    try:                               
        response4set2gpu = cc2xi.set2gpu(task4set2gpu)                                                        
        print('(Step 8B/33) OF GPU4XI5TEST - RESPONSE4SET2GPU : ', response4set2gpu)      
        # {'RESOLUTION2TIMER4PROFILING': 8,
        #  'ID2PLATFORM': '0000000001509568',
        #  'PROFILING2QUEUE': 'ACK8',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK8',
        #  'NATIVE2WIDTHLONG4VECTOR': 8,
        #  'SIZE2MEMORY4GLOBAL': 536870918,
        #  'NATIVE2WIDTHFLOAT4VECTOR': 8,
        #  'MAX2SIZE4WORKGROUP': 258,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 18,
        #  'SIZE2CACHE': 8,
        #  'IEEE754-2008FUSED2MULTIPLY-ADD': 'ACK8',
        #  'TYPE4CACHE': 8,
        #  'PREFERRED2WIDTHINT4VECTOR': 8,
        #  'MAX2FREQUENCY4CLOCK': 758,
        #  'NATIVE2WIDTHINT4VECTOR': 8,
        #  'SIZE2BUFFER4CONSTANT': 65538,
        #  'EXECUTE2FUNCTION4NATIVE': 'NACK8',
        #  'PREFERRED2WIDTHDOUBLE4VECTOR': 8,
        #  'MAX2NUMBER4CONSTANTARGS': 8,
        #  'VERSION2DRIVER': 'CAL 1.4.908',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_gl_sharing cl_amd_device_attribute_query cl_khr_d3d10_sharing8',
        #  'AVAILABLE2COMPILER': 'ACK8',
        #  'MAX2DIMENSIONS4WORKITEMS': 8,
        #  'SUPPORT2CORRECTION4ERROR': 8,
        #  'BITS2ADDRESS': 38,
        #  'AVAILABLE': 'ACK8',
        #  'SIZE2MEMORY4LOCAL': 16388,
        #  'VENDOR': 'Advanced Micro Devices Inc8',
        #  'SUPPORT2IMAGE': 'NACK8',
        #  'MAX2SIZE4KERNELARGUMENT': 1028,
        #  'ACK2RETURN': ' 2A3A4A4C4F4H5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A',
        #  'OUT-OF-ORDER2QUEUE': 'NACK8',
        #  'ALIGNMENT2ADDRESS4BASE': 32768,
        #  'PROFILE': 'FULL_PROFILE8',
        #  'TYPE2MEMORY4LOCAL': 'Global8',
        #  'PREFERRED2WIDTHFLOAT4VECTOR': 8,
        #  'PREFERRED2WIDTHLONG4VECTOR': 8,
        #  'MAX2UNITS4COMPUTE': 10,            <-- corrected
        #  'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 40218,
        #  'MAX2WORKITEM2': 258,
        #  'NATIVE2WIDTHDOUBLE4VECTOR': 8,
        #  'ROUND2ZERO': 'ACK8',
        #  'NAME': 'ATI RV7708',
        #  'MAX2WORKITEM1': 258,
        #  'NATIVE2WIDTHCHAR4VECTOR': 8,
        #  'SIZE2LINE4CACHE': 8,
        #  'MAX2ALLOCATION4MEMORY': 134217728,
        #  'MAX2WORKITEM0': 258,
        #  'QUIET2NANS': 'ACK8',
        #  'NATIVE2WIDTHSHORT4VECTOR': 8,
        #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 68,
        #  'ROUND2NEAREST4EVEN': 'ACK8',
        #  'VERSION': 'OpenCL 1.0 ATI-Stream-v2.3 (458)',
        #  'NACK2RETURN': ' 4G',
        #  'MEMORY2UNIFIED4HOSTANDDEVICE': 8,
        #  'ENDIANESS2DEVICE': 'Little8',
        #  'MINIMUM2ALIGNMENT4DATATYPE': 128,
        #  'ROUND2+VE3INFINITY': 'ACK8',
        #  'TYPE': 'CL_DEVICE_TYPE_GPU8',
        #  'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'NACK8'}

        
    except:
        print('(Step 8Z1/33) OF GPU4XI5TEST *** FAILED TO SET GPU ID AND TYPE ', time4xi())   
        
     
    
    # ---------------------------------------------------------------------------------------------
    # GET WITH METHOD AFTER RESET                    
    # ---------------------------------------------------------------------------------------------          
    print('(Step 12A/33) OF GPU4XI5TEST - TRYING TO GET DEVICE')
    try:                               
        gpu12xi = cc2xi.get2gpu()                                  
        print('(Step 12B/33) OF GPU4XI5TEST - GOT GPU: ', gpu12xi)                                                 
        # {'RESOLUTION2TIMER4PROFILING': 8, 'ID2PLATFORM': '0000000001509568', ...

    except:
        print('(Step 12Z/33) OF GPU4XI5TEST *** FAILED TO GET DEVICE')          
           
    # ---------------------------------------------------------------------------------------------
    # SENSE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 15A/33) OF GPU4XI5TEST - SENSING ', time4xi())
    print('=' *33)      
    
    try:
        print(cc2xi.sense())
    
        print('=' *33)          
        print('(Step 15B/33) OF GPU4XI5TEST - SENSED ', time4xi())
        # {'object': <gpu2device4xi.GPU4Xi object at 0x00000000028C9D68>, 'classvariable2gpu-of-GPU4Xi': 10}
        
        print('=' *33)
    except:
        print('(Step 15Z/33) OF GPU4XI5TEST *** FAILED TO SENSE ', time4xi())          
        
    # ---------------------------------------------------------------------------------------------
    # REASON                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 17A/33) OF GPU4XI5TEST - REASONING ', time4xi())
    print('=' *33)       
    
    try:
        print(cc2xi.reason())
    
        print('=' *33)          
        print('(Step 17B/33) OF GPU4XI5TEST - REASONED ', time4xi())
        # {'object-reason-object4xi': <gpu2device4xi.GPU4Xi object at 0x00000000028C9D68>, 'time-reason-of-GPU4Xi': '12:12:00 05/04/11 Pacific Daylight Time'}  
        
        print('=' *33)       
    except:
        print('(Step 17Z/33) OF GPU4XI5TEST *** FAILED TO REASON ', time4xi())                                      
             
    # ---------------------------------------------------------------------------------------------
    # ACE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 21A/33) OF GPU4XI5TEST - ACING ', time4xi())
    print('=' *33)       
    
    try:
        print(cc2xi.ace())
    
        print('=' *33)          
        print('(Step 21B/33) OF GPU4XI5TEST - ACED ', time4xi()) 
        # {'cores-of-GPU4Xi': 10, 'object8xi': <gpu2device4xi.GPU4Xi object at 0x00000000028C9D68>} 
        
        print('=' *33) 
    except:
        print('(Step 21Z/33) OF GPU4XI5TEST *** FAILED TO ACE ', time4xi())                                                
     
    # ---------------------------------------------------------------------------------------------
    # DONE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33/33) OF GPU4XI5TEST - DONE! ', time4xi())
    # 12:12:00 05/04/11 Pacific Daylight Time 
    print('=' *33) 
        
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    print_trace4xi(t2xi)        
           
      
#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
# main function for gpu2device4xi5test
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():
       
    print('=' *33)
    print("(Step 0A/33) OF GPU4XI5TEST - SENSING IT WITH YOURDRAGONXI!", time4xi())  
    print('=' *33)
        
    gpu2device4xi5test()  
    
    print('=' *33)
    print("(Step 0B/33) OF GPU4XI5TEST - SENSED IT WITH YOURDRAGONXI!", time4xi())    
    print('=' *33) 
                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# gpu2device4xi5test.txt
# sense-gpu2device4xi5test.xml
# reason-gpu2device4xi5test.xml
# ace-gpu2device4xi5test.xml
#" 
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>



#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of gpu2device4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
